import java.io.*;
import java.util.Vector;

public class BTBulkLoad implements Serializable {

    static final int MAX = 4;

    // _data contains a Vector of leaf entries;
    Vector _data = new Vector();


    public BTBulkLoad (Vector data) /*Vector data)*/ {
      _data = data;
          
    }
    
    /* build the leave entry node list */ 
    public Leaf buildLeaf() {

      int totalVals = _data.size();

      Leaf beginLeafList= null;
      Leaf leaf= null, prevLeaf = null;
      
      int index = 0;
     
//System.out.println(" in BuildLeaveList, total Vals = "+totalVals);

      while (index < totalVals) {
          leaf = new Leaf();
          if (index == 0)
              beginLeafList = leaf;
          if (prevLeaf != null)
              prevLeaf._next = leaf;
          
          int j = 0;
          // Only fill-in half of the entries for future updates
          while ((j < MAX) && (index < totalVals)) {
            leaf.insertIntoPosition(j,(LeafEntry)_data.elementAt(index));
            j++;
            index++;
          } 
          leaf._arity = j;
          prevLeaf = leaf;
      }
      return beginLeafList;
    }

    public Vector buildFirstInternalLayer(Leaf listHead) {
      
System.out.println(" In buildFirstLayer");
      Vector nodeV  = new Vector();

      Leaf curr = listHead;
      while (curr != null) {
              Node node = new Node();
              int i = 0;              
              node._children[0] = curr; 
              while ((i < MAX) && (curr._next != null)){
                  curr= curr._next; 
                  NodeEntry nodeEntry = new NodeEntry(curr._keys[0],curr);
                  node.insertIntoPosition(nodeEntry,i);
                  i++;
              }
              node._arity = i;
              nodeV.addElement(node);
              curr = curr._next;
      }


  for (int m = 0; m < nodeV.size(); m++) {

      Node currNode = (Node) nodeV.elementAt(m);
      System.out.print(" Child " + currNode._children[0]);
      for (int i = 0; i <currNode._arity ;i++){
          System.out.print(" key " + currNode._keys[i]);
          System.out.print(" Child " + currNode._children[i+1]);
      }
  }

      System.out.println("");
      System.out.println("~~~~~~~~~~~~~~");
      return nodeV;
    }

    public Vector buildInternal(Vector lowerV) {
        
//System.out.println(" In buildInternalLayer");
      Vector currNodeV = new Vector();
      int totalLower = lowerV.size();
      int index = 0;
      while (index < totalLower) {
          Node node = new Node();
          node._children[0] = lowerV.elementAt(index);
          int j = 0;
          index++;
          while ((j < MAX) && (index < totalLower)) {
              Node child = (Node) lowerV.elementAt(index);
              NodeEntry nodeEntry = new NodeEntry(child._keys[0],child);
              node.insertIntoPosition(nodeEntry,j);
              j++;
              index++;
          }
          node._arity = j;
          currNodeV.addElement(node);
      }
   for (int m = 0; m < currNodeV.size(); m++) {

      Node currNode = (Node) currNodeV.elementAt(m);
      System.out.print(" Child " + currNode._children[0]);
      for (int i = 0; i < currNode._arity;i++){
          System.out.print(" key " + currNode._keys[i]);
          System.out.print(" Child " + currNode._children[i+1]);
      }

  }

      System.out.println("");
      System.out.println("~~~~~~~~~~~~~~");

     return currNodeV;
    }

    public Node buildTree() {
      Leaf leafList = buildLeaf();
      Vector nodeV = buildFirstInternalLayer(leafList);

      while (nodeV.size() > 1) { 
            nodeV = buildInternal(nodeV);
      }
      return (Node) nodeV.elementAt(0);
    }




/*
    public static void main(String[] args) {
        BTBulkLoad btree = new BTBulkLoad();
        Node _root = btree.buildTree();
//        System.out.println(" size of root "+ _root._arity);
        for (int i = 0; i < _root._arity; i++) {
//           System.out.println("key is "+ _root._keys[i]);
        }
    }
*/
}

