import java.io.*;
import java.util.*;

public class Init{
    public static void main(String[] args){

	Init init = new Init();

	init.createInfo();

	init.infoRetrieve();

	init.buildIndex();
    }

    private void createInfo(){

	//construct file info table
	FileScan fscan = new FileScan("/afs/cs.wisc.edu/u/q/i/qing/private/cs367/p2grade");
	//write fileInfoV to stable storage
	ourDB.writeFileInfoV();
    }

    private void infoRetrieve(){

	//get vector of words extracted from the files
	WordExtractor we = new WordExtractor();
	we.buildAllWord();

	//get metadata of files
	MetaData md = new MetaData();
	md.buildAllMeta();
	
	//get semantic information of files
	SemExtract se = new SemExtract();
	se.extract();
    }

    private void buildIndex(){

	BPlusTree btbl;
	TreeToFile ttf = new TreeToFile();

	//build index tree of plain text words
	btbl = new BPlusTree("TEXT");
       	btbl.BKLoad(ourDB.wordsForBL);
	ttf.toFile(btbl, "TEXT");

	//build index trees of metadata
	btbl = new BPlusTree("META_OWNER");
	btbl.BKLoad(ourDB.metaForBL[0]);
	ttf.toFile(btbl, "META_OWNER");
	
	btbl = new BPlusTree("META_GROUP");
	btbl.BKLoad(ourDB.metaForBL[1]);
	ttf.toFile(btbl, "META_GROUP");

	btbl = new BPlusTree("META_SIZE");
	btbl.BKLoad(ourDB.metaForBL[2]);
	ttf.toFile(btbl, "META_SIZE");
	
	btbl = new BPlusTree("META_ACCESST");
	btbl.BKLoad(ourDB.metaForBL[3]);
	ttf.toFile(btbl, "META_ACCESST");

	btbl = new BPlusTree("META_MODT");
	btbl.BKLoad(ourDB.metaForBL[4]);
	ttf.toFile(btbl, "META_MODT");

	btbl = new BPlusTree("META_CHANGET");
	btbl.BKLoad(ourDB.metaForBL[5]);
	ttf.toFile(btbl, "META_CHANGET");

	//build index trees of semantics
	//mailHashT: sender, receiver, date, subject
	//javaHashT: import, public, class
	//cHashT:

	try{
	    FileOutputStream fos  = new FileOutputStream("mailHashT");
	    ObjectOutputStream out = new ObjectOutputStream(fos);
	    out.writeObject(ourDB.mailHashT);
	    out.flush();
	    out.close();
	}catch(IOException e){
	    System.out.println(e);
	}

	for(Enumeration e = ourDB.mailHashT.keys(); e.hasMoreElements();){
	    String key = (String)e.nextElement();
	    String fileName = key+"_INDEX";
	    BPlusTree tree = (BPlusTree)(ourDB.mailHashT.get(key));
	    ttf.toFile(tree, fileName);
	}

	try{
	    FileOutputStream fos  = new FileOutputStream("javaHashT");
	    ObjectOutputStream out = new ObjectOutputStream(fos);
	    out.writeObject(ourDB.javaHashT);
	    out.flush();
	    out.close();
	}catch(IOException e){
	    System.out.println(e);
	}
	
	for(Enumeration e = ourDB.javaHashT.keys(); e.hasMoreElements();){
	    String key = (String)e.nextElement();
	    String fileName = key+"_INDEX";
	    BPlusTree tree = (BPlusTree)(ourDB.javaHashT.get(key));
	    ttf.toFile(tree, fileName);
	}
	/*
	try{
	    FileOutputStream fos  = new FileOutputStream("cHashT");
	    ObjectOutputStream out = new ObjectOutputStream(fos);
	    out.writeObject(ourDB.cHashT);
	    out.flush();
	    out.close();
	}catch(IOException e){
	    System.out.println(e);
	}

	for(Enumeration e = ourDB.cHashT.keys(); e.hasMoreElements();){
	    String key = (String)e.nextElement();
	    String fileName = key+"_INDEX";
	    BPlusTree tree = (BPlusTree)(ourDB.cHashT.get(key));
	    ttf.toFile(tree, fileName);
	}
	*/
	
    }
}








