#include "ConvertTime.h"
#include <jni.h>
#include <stdio.h>
#include <time.h>

time_t parse_time (const char *s) 
{
        struct tm t;
        t.tm_isdst = -1;
        sscanf(s, "%d/%d/%d %d:%d:%d",
               &t.tm_mon,
               &t.tm_mday,
               &t.tm_year,
               &t.tm_hour,
               &t.tm_min,
               &t.tm_sec);
        t.tm_year -= 1900;
        t.tm_mon--;
        return mktime(&t);
}


JNIEXPORT jlongArray JNICALL Java_ConvertTime_parseDate
    (JNIEnv *env, jobject jobj, jstring date){
    jlong j[1];
    jlongArray jl;
    jboolean isCopy;

    const char *mfile = env -> GetStringUTFChars(date, &isCopy);

    j[0] = parse_time(mfile);
    jl = env -> NewLongArray(1);
    env -> SetLongArrayRegion(jl, 0, 1, j);

    env -> ReleaseStringUTFChars(date, mfile); 
    return jl;
}










