#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>//for open()
#include <sys/mman.h>//for mmap()
#include <unistd.h> //for close()
#include <stdio.h>
#include "MetaData.h"
#include <jni.h>
#include <iostream.h>

JNIEXPORT jlongArray JNICALL Java_MetaData_getInfo
    (JNIEnv *env, jobject jobj, jstring name) {
    jlong j1[6];
    jlongArray jl;
    jboolean iscopy;
    struct stat finfo;
    const char *mfile = env->GetStringUTFChars(name, &iscopy);
    int fd = open(mfile, O_RDONLY);
    if (fd == -1) {
	printf("Could not open %s\n", mfile);
    }
    stat(mfile, &finfo);
    jl = env->NewLongArray(6);
    j1[0] = (long)finfo.st_uid;//The number of links 
    j1[1] = (long)finfo.st_gid;//The user ID of file owner
    j1[2] = (long)finfo.st_size;//The file size in bytes
    j1[3] = (long)finfo.st_atime;//The time of last access
    j1[4] = (long)finfo.st_mtime;//The time of last data modification
    j1[5] = (long)finfo.st_ctime;//The time of last file status change
    env -> SetLongArrayRegion(jl, 0, 6, j1);
    close(fd);
    env->ReleaseStringUTFChars(name, mfile);
    return (jl);

}
