import java.io.*;
import java.util.*;
import java.util.StringTokenizer;
import java.lang.*;

public class MailTrans {


    private final static String _sDate = "Date:";
    private final static String _sSender = "From:"; 
    private final static String _sreceiver = "To:";
    private final static String _sCc = "cc:";
    private final static String _sTo = "To:";
    private final static String _sSub = "Subject:";
    private final static String _sContentType ="Content-Type";
    private final static String _sBeginContent = "X-Status:";

    private String _sender="";
    private String _senderEmail;
    private String _receiver="";
    private String _receiverEmail="";
    private String _date= "";
    private String _subject="";
    private String _contentType ="";
    private Vector _text = new Vector();
    
    MailContent _content;
    int _fileNo;


    // From: <email addr>
    // Date:
    // From: <name> < email addr in <> >
    // To:   <name> < email addr in <> >
    // cc:
    // Subject: 
    // Message-ID:
    // Content-Type: < >/< >
    // Status:
    // X-Status:
    
        

    public void getDate(StringTokenizer str) throws IOException {
          _date = str.nextToken();
          while (str.hasMoreTokens()) 
            _date = _date + " " + str.nextToken();
          System.out.println("date = " + _date);
    }

    public void getSender(StringTokenizer str) throws IOException {
//System.out.println(" IN GET SENDER");

          _sender = str.nextToken();
          _sender = _sender + " " + str.nextToken();
          System.out.println("sender = " + _sender);

          _senderEmail = getEmailAddr(str.nextToken());
    }
     public void getReceiver(StringTokenizer str) throws IOException {
//System.out.println(" IN GET Receiver");

          _receiver = str.nextToken();
          _receiver = _sender + " " + str.nextToken();
          System.out.println("receiver = " + _sender);

          _receiverEmail = getEmailAddr(str.nextToken());
    }
    
    private String getEmailAddr(String inAddr) {
        
        int size = inAddr.length();
          
        return (inAddr.substring(1,size-1));
    }
 
    
    public void getSubject(StringTokenizer str) throws IOException {
//System.out.println(" IN GET Subject");

      //get  the subject heading
      while (str.hasMoreTokens()) 
              _subject = _subject+ " "+  str.nextToken();
      System.out.println("subject= " + _subject);
    }


    public void getContentType(StringTokenizer str) throws IOException {
      
//System.out.println("IN GET CONTENT-TYPE!");
      //get  the subject heading
      _contentType= str.nextToken();
      int length = _contentType.length();
      if (_contentType.charAt(length-1) ==';')
          _contentType = _contentType.substring(0,length-1);

      System.out.println("ContentType = " + _contentType);
    }
 

    public void getText(BufferedReader fin) throws IOException {

      if (isPlainText()) {
          while (fin.ready()) {
              String line = fin.readLine();
              _text.addElement(line);              
          }

      }
    }

    public boolean isPlainText() {
      return (_contentType.equalsIgnoreCase("text/plain"));
    }

    public MailContent  getData(int fileNo,String fname) throws IOException,FileNotFoundException {
      _fileNo = fileNo;

      File inFile = new File(fname);

      BufferedReader fin = new BufferedReader(new FileReader(inFile));
      String line;
      boolean stop = false;
      
      //get header data
      while (!stop) {
          line = fin.readLine();
//System.out.println("STRING = " + line);
          StringTokenizer str = new StringTokenizer(line);
          String currWord = str.nextToken();
          if (currWord.startsWith(_sDate))
              getDate(str);
          else 
          if (currWord.startsWith(_sSender))
              getSender(str);
          else 
          if (currWord.startsWith(_sSub))
              getSubject(str);
          else
          if (currWord.startsWith(_sContentType))
              getContentType(str);
          else
          if (currWord.startsWith(_sBeginContent))
              stop = true;
      }

      //get the text part;
      getText(fin);

      //create the mailcontent object
      _content = new MailContent(_sender,_senderEmail,_receiver,_receiverEmail,_subject,_date,_contentType,_text); 
      _content.printContent();
      return _content;
  }

    
             
      
  
/*
          String subject = str.nextToken();
          line = fin.readLine();
          str = new StringTokenizer(line);
          currWord = str.nextToken();
         // get to the line that symbolize the begining of plain text
          // region
          while (currWord.compareTo(_sbeginText)!=0) {
                line = fin.readLine();
                str = new StringTokenizer(line);
                currWord = str.nextToken();
          }
                    
   
    public static void main(String[] args) throws IOException {

        MailTrans thisTrans = new MailTrans();
        thisTrans.getData(args[0]);
    }
*/


}
        
              

      
