import java.io.Serializable;
import java.util.Vector;
import java.lang.String;

public class Node implements Serializable {

    static final int MAX = 4;
    static final int MIN = MAX/4;

    String[] _keys;
    Object[] _children;

    int[] _size;
    int   _arity; // # of keys  which is 1 less than the number of pointers;
    
    public Node() {
        _keys = new String[MAX];
        _children = new Object[MAX+1]; 
        _size = new int[MAX]; 
        _arity = 0;
    }
    
    public Node(String[] keys, Object[] children, int[] size, int arity) {
        _keys = keys;
        _children = children;
        _size = size;
        _arity = arity;
    }

    /* lookup of an item with key = key */
    public Object lookup(String key) {


        int i= 0;
        boolean stop = false;

System.out.println(" ~~~~~~~~NODE LOOK UP for key "+ key +"~~~~~~");

         while ((i < _arity) && (!stop)) {
  System.out.println("NODE KEY i = " + _keys[i]+ " Child = "+ _children[i]);
  
            if (_keys[i].compareTo(key) > 0) {

               stop = true;
               if (_children[i] instanceof Node) 
                    return ((Node)_children[i]).lookup(key);

               else {
                 System.out.println(" got ot Leave "+ _children[i]);
                    return ((Leaf) _children[i]).lookup(key);
               }
            } 
            else 
                i++;
        }
        
        if (_children[i] instanceof Node)
                return ((Node)_children[i]).lookup(key);

        else  {
System.out.println(" last chiled....got ot Leave "+ _children[i]);
                return ((Leaf) _children[i]).lookup(key);
        }
    }

    public NodeEntry insert(String key, Object values) {
        
System.out.println("~~~~~~~~~~~~~~~~~~~ In node insert");

        boolean stop = false;

        NodeEntry newNode = null;
System.out.println(" arity is "+ _arity);

for (int i = 0; i < _arity; i++)
    System.out.print("key : " + _keys[i] + " child : " + _children[i]);

System.out.println("Done printing this node,now begin insert");



        int i= 0;

         while ((i < _arity) && (!stop)) {
            if (_keys[i].compareTo(key) > 0) {


               if (_children[i] instanceof Node) {
                 
System.out.println("to Next NOde");
                  stop = true;
                  newNode = ((Node) _children[i]).insert(key, values);
                  
                }
                else {

if (_children[i] instanceof String)
System.out.println("is a String");
                    
System.out.println("to Next Leaf + "+ _children[i]);
                    
                    stop = true;
                    LeafEntry entry = new LeafEntry(key, (Vector)values);
                    newNode = ((Leaf) _children[i]).insert(entry);
               } //end-if
            }// end-if;
            i++;
        }

        if (!stop) {
            if (_children[i] instanceof Node) {
System.out.println("to Next NOde");

                newNode = ((Node) _children[i]).insert(key, values);
                return newNode;
            }
            else {
System.out.println("to Next LEAF " + (Leaf) _children[i] );

                  LeafEntry entry = new LeafEntry(key, (Vector)values);
                  newNode = ((Leaf) _children[i]).insert(entry);
            }
        }

        if (newNode != null) {

System.out.println("~~~~~~~~~~~~~~got someting back from child, need to add");
System.out.println("got  this promoted child " + newNode);

           int position = getPosition(newNode._key);
           newNode = addEntry(newNode,position);
        }

System.out.println(" after add the NEW ENTRY the node is : ");

for (int j = 0; j < _arity; j++) {
      System.out.println("Key : " + _keys[j] + "child " + _children[j]);
} 
        return newNode;
    }


    // Split the node into two when it is full by copying the last
    // half of the old node into the newNode.
    public NodeEntry split(NodeEntry entry,int position) {
      
  System.out.println(" ~~~~~~~~~~~~IN NODE SPLIT!!!!!!!!!!!!");
        
        Node newNode = new Node();
        
        int newSize = MAX/2;
        int moveIndex = (position < MAX/2)? MAX/2 : MAX/2+1;

        //find the node entry to be promoted up
        // if the position of the new node to be added is just
        // in the middle, then its key and the associated newly
        // created split node is the new node entry,
        // if the position of th new node to be added is within
        // the scope of old entry, then it means that all the
        // rest of the entries will be shifted one place backward
        // thus making the node entry at [MAX/2-1] to be the key that
        // is going to be promoted.  Else the key to be promoted will
        // be the MAX/2 entry. The children pointer to be promoted will
        // be always the one that point to the new node created by split.



        int oldArity = _arity;
        int newArity = 0;
        NodeEntry middle = null;
        if (position == MAX/2) {
            middle = new NodeEntry(entry._key, newNode);
            moveIndex = MAX/2;
        
            // move half of the original entry into new node 

            newNode._children[0] = middle._child;

            for (int i =0; i < newSize;i--) {
                  moveIndex = MAX-1 -i;
                  newNode._keys[newSize-i-1]= _keys[moveIndex];
                  newNode._children[newSize-i] = _children[moveIndex+1];
                  _keys[moveIndex] = null;
                  _children[moveIndex+1]= null;
                  oldArity = oldArity-1;
                  newArity +=1;
                  
            }
        }
        else {
            if (position < MAX/2) {
                middle = new NodeEntry(_keys[MAX/2-1], newNode);
                _keys[MAX/2-1] = null;

                moveIndex = MAX/2;
                for (int i = moveIndex; i<MAX; i++){
                    newNode._keys[i-moveIndex] = _keys[i];
                    newNode._children[i-moveIndex] = _keys[i];
                    _keys[i] = null;
                    _children[i]= null;
                    oldArity -=1;
                    newArity +=1;
                }
                newNode._children[MAX-moveIndex] = _children[MAX];
                _children[MAX] = null;

                // remove the key that got promoted from this level of nodes.
                for (int i = MAX/2-1; i > position ;i--) {
                    _keys[i] = _keys[i-1];
                    _children[i+1] = _children[i];
                }

                _keys[position] = entry._key;
                _children[position+1] = entry._child;
            }
            else {
                  middle = new NodeEntry(_keys[MAX/2], newNode);
                  _keys[MAX/2] = null;

                  moveIndex = MAX/2+1;
                
                  for (int i =moveIndex; i < MAX;i++) {
                      newNode._keys[i-moveIndex]= _keys[i];
                      newNode._children[i-moveIndex] = _children[i];
                      _keys[i] = null;
                      _children[i]= null;
                      oldArity -=1;
                      newArity +=1;
                  }

                  newNode._children[MAX-moveIndex] = _children[MAX];

                  int newPos = position - moveIndex; 

                  for (int i = newArity; i > newPos; i--){

                      newNode._keys[i] = _keys[i-1];
                      newNode._children[i+1] = _children[i];
                  }
                  newNode._keys[newPos] = entry._key;
                  newNode._children[newPos+1] = entry._child;
                  newArity +=1;

              } // end-if
        } //end-if

        newNode._arity = newArity;
        _arity = oldArity;


System.out.println("NEW NODE is "+ newNode);
System.out.println("promoted key "+ middle._key +" pointer to " + middle._child);
if (!(middle._child instanceof Node)){
  System.out.println(" NODE SPLIT WORNG");
  System.exit(0);
}
        return middle;
    }    

    // add the node entry into place denoted by position.
    public NodeEntry addEntry(NodeEntry entry,int position){ 


if (!(entry._child instanceof Node)) {
  if  (!(entry._child instanceof Leaf)){
  System.out.println(" NODE ADD WORNG");
  System.exit(0);
  }
}
  
System.out.println(" ~~~~~~~~~ ADD entry to position = " + position);

          if (_arity < MAX) {
              orderedInsert(entry,position);
              return null;
          }
          else 
            return split(entry,position);
    }
             
    /* insert the promoted entry to the current node. */
    private void orderedInsert(NodeEntry entry,int position) {

        // move the entries have key greater than the key to be
        // inserted one position back.
        // the entry to be added is the key plus the pointer behind it
        // which is at the position of 1 more than that of the key.
        // since the number of pointers is 1 more than keys 
        // and we need to move only the set of key and pointer
        // after the key and pointer to be inserted thus the position
        // of the pointers to be moved is 1 more than that of the keys.
       
        moveDataBackward(position);
        insertIntoPosition(entry,position);
   }         
          
    public void moveDataBackward(int beginPos) {

        for (int i = _arity; i > beginPos; i--) {
            _keys[i] = _keys[i-1];
            _children[i+1] = _children[i];
        }

    }


    public void insertIntoPosition(NodeEntry entry, int position) {

         // insert the entry into the appropriate position
        _keys[position] = entry._key;
        _children[position+1] = entry._child;
        _arity++;
    }
    
 

    /* search for the ordered position where the new node entry should
     * be placed */
    private int getPosition(String key) {

        int pos = 0;
        for (int i = 0; i < _arity; i++) {
            if (_keys[i].compareTo(key) > 0) 
                return i;
        }
        return _arity;
    }

}

            
      

