import java.util.Vector;
import java.lang.*;
import java.io.*;
import java.util.Hashtable;


public class Query implements Serializable {

  /* The existing indices are
    1) textTree;
    2) javaTree;
    3) cPlusTree;
    4) mailTree;
        a) Sender;
        b) Receiver;
        c) Subject;
        d) Date;
    5) ownerTree;
    6) modifTimeTree;
  */


  public Hashtable getMailTable() {
      Hashtable mailHashT = new Hashtable();

      try {
          FileInputStream fi = new FileInputStream("mailHashT");
          ObjectInputStream si = new ObjectInputStream(fi);
          mailHashT = (Hashtable) si.readObject();
          si.close();
      } catch (Exception e) {
          e.printStackTrace();
      }
      return mailHashT;
  }

 
  public Hashtable getJavaTable() {
      Hashtable javaHashT = new Hashtable();

      try {
          FileInputStream fi = new FileInputStream("javaHashT");
          ObjectInputStream si = new ObjectInputStream(fi);
          javaHashT = (Hashtable) si.readObject();
          si.close();
      } catch (Exception e) {
          e.printStackTrace();
      }
      return javaHashT;
  }


  public Vector textQuery(String[] values) {
      BPlusTree BTree = new BPlusTree("TEXT_INDEX");

      BTree = getThisTree("TEXT_INDEX");

      Vector resV = new Vector();

      int size = values.length;
      resV = (Vector) BTree.lookup(values[0]);

      for (int i = 1; i < size; i++) {
        
          Vector v = (Vector) BTree.lookup(values[i]);
          int vecSize = v.size();
          for (int j = 0; j <vecSize; j++) {
              resV.addElement(v.elementAt(j));
          }
      }

      return resV;

      
  }

   public Vector metaQuery(String type, String value) {

      BPlusTree BTree = new BPlusTree(type+"_INDEX");

      BTree = getThisTree(type+"_INDEX");

      return BTree.lookup(value);

  }


  public Vector mailQuery(String[] types, String[] values) {

      
      int size = values.length;
      BPlusTree[] BTrees = new BPlusTree[size];

      for (int i = 0; i < size; i++) {
          BTrees[i] = getThisTree(types[i]+"_INDEX");
      }

      Vector resV = new Vector();

      resV = (Vector) BTrees[0].lookup(values[0]);

      for (int i = 1; i < size; i++) {
        
          Vector v = (Vector) BTrees[i].lookup(values[i]);
          int vecSize = v.size();
          for (int j = 0; j <vecSize; j++) {
              resV.addElement(v.elementAt(j));
          }
      }

      return resV;
  }
  public Vector javaQuery(String[] types, String[] values) {

      
      int size = values.length;
      BPlusTree[] BTrees = new BPlusTree[size];

      for (int i = 0; i < size; i++) {
          BTrees[i] = getThisTree(types[i]+"_INDEX");
      }

      Vector resV = new Vector();

      resV = (Vector) BTrees[0].lookup(values[0]);

      for (int i = 1; i < size; i++) {
        
          Vector v = (Vector) BTrees[i].lookup(values[i]);
          int vecSize = v.size();
          for (int j = 0; j <vecSize; j++) {
              resV.addElement(v.elementAt(j));
          }
      }

      return resV;
  }




  public BPlusTree getThisTree(String treeType) {
    
     BPlusTree tree = null;
     try {
          FileInputStream fi = new FileInputStream(treeType);
          ObjectInputStream si = new ObjectInputStream(fi);
          tree  = (BPlusTree) si.readObject();
          si.close();
      } catch (Exception e) {
          e.printStackTrace();
      } 

     return tree;
  }
  
}
/*
  public Vector mailQuery(String type, String value) {

      Hashtable mailHashT = getMailTable();

      BPlusTree BTree = new BPlusTree("MAIL");

      String treeType = (String) mailHashT.get(type);
      BTree = getThisTree(treeType);

      return (Vector) BTree.lookup(value);
  }
        

      // get the file number lists that satisfy each pattern and put them
      // into an array of Vectors of file numbers

      Vector[] vecArray = new Vector(types.length);
      for (int i = 0; i < types.length; i ++) {
          vecArray[i] = BPlusTree[i].lookup(values[i]);
      }

      // now need to intersect them to get the final output

      return intersect(vecArray);
  }
  public Vector javaQuery(String type, String value) {

      Hashtable javaHashT = getJavaTable();

      BPlusTree BTree = new BPlusTree("JAVA");

      String treeType = (String) javaHashT.get(type);
      BTree = getThisTree(treeType);

      return (Vector) BTree.lookup(value);
  }

  */

      
