/* This class will parse a simple query and convert it to a SimpleQueryEntry
 * object.
 */

import java.util.*;

public class SimpleQueryParsing {

    // parse the query string and return a SimpleQueryEntry object
    public static SimpleQueryEntry parse(String query) {

	// get the field name
	int pos = query.indexOf(':');

	// wrong query format
	if (-1 == pos) {
	    System.out.println("ERROR: ':' is needed for field.");
	    return null;
	}

	if ('/' != query.charAt(0)) {
	    System.out.println("ERROR: '/' missing before a simple query.");
	    return null;
	}

	String field = query.substring(1,pos);

	if ((pos != query.length()-1) && ('/' != query.charAt(pos+1))) {
	    System.out.println("ERROR: the desired value of a field must begin with '/'.");
	    return null;
	}

	if ((-1 != query.indexOf(':',pos+1)) || (-1 != query.indexOf('/',pos+2))) {
	    System.out.println("ERROR: operator missing.");
	    return null;
	}

	// get the value of the field
	if (query.lastIndexOf('/') == query.indexOf('/')) {
	    // there is no field value
	    return (new SimpleQueryEntry(field,""));
	}
	else {
	    return (new SimpleQueryEntry(field, query.substring(pos+2)));
	}
    }
}


		

		
