/* this file will define the data structure for the query result of each single
 * query.
 */

import java.util.*;

public class SingleQueryResult {

    public Vector singleResult = new Vector();

    public int parent = -1;

    public static int position = -1;
    // search a name from the current query result.
    // if found, return id or type, otherwise return Interger.MAX_VALUE
    public int search(String name) {
	
	// first get to the requested virtual dir
	StringTokenizer st = new StringTokenizer(name,"/");

	if (1 == st.countTokens()) {

	    if (name.equals("..")) {
		return -1;
	    }
				    
	    // there is no dir in the given name, so find the name
	    // in this query result object
	    for (int i=0; i<singleResult.size(); i++) {
		if ((((QueryResultEntry)singleResult.elementAt(i)).name)
		    .equals(name))
		    return ((QueryResultEntry)(singleResult.elementAt(i)))
			.fileNumOrDirType;
	    }

	    // the name is not found in this query result object
	    System.out.println("ERROR: " + name + " not found.");
	    return Integer.MIN_VALUE;
	}
	else {
	    // there are dirs in the representation of name, so first
	    // find the correct pointer for query result in QueryResultTree
	    //for (int i=0; i<st.countTokens()-1; i++) {
	    String dirname = st.nextToken();

	    if (dirname.equals("..")) {

		// go to the parent query
		if (-1 == parent) {
		    System.out.println("ERROR: root query result is exceeded.");
		    return Integer.MIN_VALUE;
		}
		else {
		    name = name.substring(name.indexOf("/")+1);
		    return ((SingleQueryResult)((QueryResultTree.resultTree).elementAt
						(parent))).search(name);
		}
	    }
	    else {
		// find the dir name in current query
		for (int i=0; i<singleResult.size(); i++) {
		    if ((((QueryResultEntry)singleResult.elementAt(i)).name)
			.equals(dirname)) {
			if ( 0 <= ((QueryResultEntry)(singleResult.elementAt(i)))
			     .fileNumOrDirType) {
				// it is not a virtual dir
			    System.out.println("ERROR: " + dirname + " is not a " +
					       "virtual directory.");
			    return Integer.MIN_VALUE;
			}
			else {
			    int child = ((QueryResultEntry)(singleResult.elementAt(i))).child;
			    if (-1 == child) {
				System.out.println("ERROR: " + dirname + " has not done "
						   + "subquery yet.");
				return Integer.MIN_VALUE;
			    }
			    else {
				name = name.substring(name.indexOf("/")+1);
				return ((SingleQueryResult)((QueryResultTree.resultTree)
							    .elementAt(child))).search(name);
			    }
			}
		    }
		}

		// the name is not found in this query result object
		System.out.println("ERROR: " + dirname + " not found.");
		return Integer.MIN_VALUE;
	    }
	}

	//return Integer.MIN_VALUE;
    }


    // search the directory along the path given
    public int searchPath(String name) {
	
		
	// first get to the requested virtual dir
	StringTokenizer st = new StringTokenizer(name,"/");

	if (1 == st.countTokens()) {
	    // there is no other dir in the given name, so find the name
	    // in this query result object
	    if (name.equals("..")) {
		// return to parent directory
		if (-1 == parent) {
		    System.out.println("ERROR: there is no parent directory.");
		    return Integer.MIN_VALUE;
		}
		else 
		    return parent;
	    }
	    
	    for (int i=0; i<singleResult.size(); i++) {
		if ((((QueryResultEntry)singleResult.elementAt(i)).name)
		    .equals(name)) {
		    
		    if (-1 == ((QueryResultEntry)(singleResult.elementAt(i))).child) {
			((QueryResultEntry)(singleResult.elementAt(i))).child = 
			    (QueryResultTree.resultTree).size();
			position = (QueryResultTree.resultTree).indexOf(this);
			return ((QueryResultEntry)(singleResult.elementAt(i))).fileNumOrDirType;
		    }
		    else
			return ((QueryResultEntry)(singleResult.elementAt(i))).child;
		}
	    }

	    // the name is not found in this query result object
	    System.out.println("ERROR: " + name + " not found.");
	    return Integer.MIN_VALUE;

	}
	else {
	    // there are multiple dirs in the representation of name, so first
	    // find the correct pointer for query result in QueryResultTree
	    //for (int i=0; i<st.countTokens()-1; i++) {
	    String dirname = st.nextToken();

	    if (dirname.equals("..")) {
		// go to the parent query
		if (-1 == parent) {
		    System.out.println("ERROR: root query result is exceeded.");
		    return Integer.MIN_VALUE;
		}
		else {
		    name = name.substring(name.indexOf("/")+1);
		    return ((SingleQueryResult)((QueryResultTree.resultTree).elementAt
						(parent))).searchPath(name);
		}
	    }
	    else {
		// find the dir name in current query
		for (int i=0; i<singleResult.size(); i++) {
		    if ((((QueryResultEntry)singleResult.elementAt(i)).name)
			.equals(dirname)) {
			if ( 0 <= ((QueryResultEntry)(singleResult.elementAt(i)))
			     .fileNumOrDirType) {
				// it is not a virtual dir
			    System.out.println("ERROR: " + dirname + " is not a " +
					       "virtual directory.");
			    return Integer.MIN_VALUE;
			}
			else {
			    int child = ((QueryResultEntry)(singleResult.elementAt(i))).child;
			    if (-1 == child) {
				System.out.println("ERROR: " + dirname + " has not done "
						   + "subquery yet.");
				return Integer.MIN_VALUE;
			    }
			    else {
				name = name.substring(name.indexOf("/")+1);
				return ((SingleQueryResult)((QueryResultTree.resultTree)
							    .elementAt(child))).searchPath(name);
			    }
			}
		    }
		}

		// the name is not found in this query result object
		System.out.println("ERROR: " + dirname + " not found.");
		return Integer.MIN_VALUE;
	    }
	}

    }


    // seach whether a dir has a child
    public int searchChild(String name) {
	
	for (int i=0; i<singleResult.size(); i++) {
	    if ((((QueryResultEntry)singleResult.elementAt(i)).name)
		.equals(name))
		return ((QueryResultEntry)(singleResult.elementAt(i)))
		    .child;
	}

	return -1;
    }

    // list all the entries of query result
    public void list() {

	for (int i=0; i< singleResult.size(); i++) {
	    System.out.print(((QueryResultEntry)(singleResult.elementAt(i)))
			     .name + "    ");
	    if ((0 == i % 5) && (0 < i))
		System.out.println();
	}
	    
	System.out.println();
    }

}

				
