/* this class will contain the query evaluation plan. */

import java.util.*;
import java.io.*;

/* treeNode class is the type of node contained in tree */
class treeNode{

    public String op = "";
    
    public SimpleQueryEntry query = null;

    public treeNode left = null;

    public treeNode right = null;

    
}

public class Tree {

    public static int attribute = 0; // used for query withoue value

    // build the tree from a query string
    public treeNode build(String query) {

	treeNode newNode = new treeNode();

	if ((-1 == query.indexOf('&')) && (-1 == query.indexOf('|'))) {
	    // it is a simple query
	    query = trimPare(query);
	    newNode.query = SimpleQueryParsing.parse(query);
	    if (null == newNode.query)
		newNode = null;
	    return newNode;
	}
	else {
	    // find the last highest level op
	    query = query.trim();
	    
	    if (query.endsWith(")")) {
		int pos = match(query, query.length()-1);
		if (0 == pos)
		    query = trimPare(query);
	    }

	    if (')' != query.charAt(query.length()-1)) {
		// the last operand is a simple query, then get
		// the position of last op
		int pos = getLastOp(query);
		newNode.op = query.substring(pos,pos+1);
		newNode.left = build(query.substring(0,pos));
		newNode.right = build(query.substring(pos+1));
	    }
	    else {
		// get the '(' that matches the last ')'
		int pos = match(query,query.length()-1);

		// get the first operand with op
		String temp = query.substring(0,pos);
		int opPos = getLastOp(temp);

		newNode.op = query.substring(opPos,opPos+1);
		newNode.left = build(query.substring(0,opPos));
		newNode.right = build(query.substring(opPos+1));
		if ((null == newNode.left) || (null == newNode.right))
		    newNode = null;
	    }

	    return newNode;
	}
    }

    // get the position of last operator in query
    private int getLastOp(String query) {

	int pos1 = query.lastIndexOf('|');
	int pos2 = query.lastIndexOf('&');

	if (pos1 > pos2)
	    return pos1;
	else
	    return pos2;
    }

    // trim the parenthesis of query
    private String trimPare(String query) {
	
	query = query.trim();

	if (query.startsWith("(") && query.endsWith(")")) {
	    query = query.substring(1,query.length()-1);
	}
	return query;
    }
	 
    // the method will return the position of a '(' which match the ')'
    // at the given position
    private int match(String s, int pos) {
	    
	boolean isMatch = false;

	int count = 1;

	for (int i=pos-1; i>=0; i--) {
	    
	    if (s.charAt(i) == ')')
		count++;
	    else if (s.charAt(i) == '(')
		count--;

	    if (0 == count) 
		return i;
	}

	return -1;
	
    }

    // evaluate a query
    public Vector evaluate(String query) {

	treeNode root = build(query);

	if (null == root)
	    return null;

	print(root);
	Vector result = compute(root);

	return result;
    }


    // evaluate a query plan tree
    private Vector compute(treeNode n) {

	Vector v = new Vector();;

	if (0 == (n.op).length()) {
	    // leaf node
	    String field = ((SimpleQueryEntry)(n.query)).field;
	    String value = ((SimpleQueryEntry)(n.query)).value;

	    System.out.println("compute: field -- " + field + "  value -- " + value);
	    if (field.equalsIgnoreCase("text")) {
		StringTokenizer st = new StringTokenizer(value,";");
		String[] paras = new String[st.countTokens()];

		for (int i=0; i<st.countTokens(); i++)
		    paras[i] = st.nextToken();
		 
		//return sort((new Query()).textQuery(paras));
		System.out.println("test1 result return");
		return sort(test1());
	    }
	    else if (field.equalsIgnoreCase("sender") ||
		     field.equalsIgnoreCase("receiver") ||
		     field.equalsIgnoreCase("date") ||
		     field.equalsIgnoreCase("subject")) {
		String[] types = new String[1];
		String[] paras = new String[1];
		types[0] = field.toLowerCase();
		paras[0] = value.toLowerCase();

		//return sort((new Query()).mailQuery(types,paras));
		System.out.println("test2 rsult return");
		if (field.equalsIgnoreCase("sender"))
		    attribute = -1;
		else if (field.equalsIgnoreCase("receiver:"))
		    attribute = -2;
		return sort(test2());
	    }
	    else if (field.equalsIgnoreCase("mail")) {
		StringTokenizer st = new StringTokenizer(value,";");
		String[] types = new String[st.countTokens()];
		String[] paras = new String[st.countTokens()];

		for (int i=0; i<st.countTokens(); i++) {
		    // get sender, receiver, date, subject one by one
		    String s = st.nextToken();
		    // position of "="
		    int pos = s.indexOf("=");
		    types[i] = ((s.substring(0,pos)).trim()).toLowerCase();
		    paras[i] = ((s.substring(pos+1)).trim()).toLowerCase();
		}

		return sort(test3());
		//return sort((new Query()).mailQuery(types,paras));
	    }
	    else if (field.equalsIgnoreCase("import") ||
		     field.equalsIgnoreCase("class") ||
		     field.equalsIgnoreCase("public")) {
 		String[] types = new String[1];
	        String[] paras = new String[1];
	        types[0] = field.toLowerCase();
	        paras[0] = value.toLowerCase();

		return sort(test1());
	        //return sort((new Query()).javaQuery(types,paras));
	    }
	    else if (field.equalsIgnoreCase("java")) { 
		StringTokenizer st = new StringTokenizer(value,";");
		String[] types = new String[st.countTokens()];
        	String[] paras = new String[st.countTokens()];

        	for (int i=0; i<st.countTokens(); i++) {
        	    // get import, class, public one by one
		    String s = st.nextToken();
		    // position of "="
		    int pos = s.indexOf("=");
		    types[i] = ((s.substring(0,pos)).trim()).toLowerCase();
		    paras[i] = ((s.substring(pos+1)).trim()).toLowerCase();
		}
		
		return sort(test2());
		//return sort((new Query()).javaQuery(types,paras));
	    }
	    else if (field.equalsIgnoreCase("size") ||
		     field.equalsIgnoreCase("owner") ||
		     field.equalsIgnoreCase("statusT") ||
		     field.equalsIgnoreCase("modifyT") ||
		     field.equalsIgnoreCase("createT")) {
		String[] types = new String[1];
		String[] paras = new String[1];
		types[0] = field.toLowerCase();
		paras[0] = value.toLowerCase();

		if (field.equalsIgnoreCase("owner"))
		    attribute = -3;
		if (value.length() == 0)
		    return sort(test4());
		else
		    return sort(test3());
		//return sort((new Query()).metaQuery(types,paras));
	    }
	    else if (field.equalsIgnoreCase("type")) {
		
		String para = value.toLowerCase();

		attribute = -4;
		return sort(test1());
		//return sort((new Query()).typeQuery(para));
	    }
	    else {
		System.out.println("ERROR: field name " + field + " does not exist.");
		return null;
	    }
	}
	else if ((n.op).equals("&")) {
	    return And(compute(n.left), compute(n.right));
	}
	else {
	    return Or(compute(n.left), compute(n.right));
	}

    }

    // compute "and" operator of two query results
    private Vector And(Vector v1, Vector v2) {

	int c1=0, c2=0;
	Vector result = new Vector();

	if ((null == v1) || (null == v2))
	    return null;

	while ((c1 < v1.size()) && (c2 < v2.size())) {
	    // get two integers from the two vectors
	    int i1 = ((Integer)(v1.elementAt(c1))).intValue();
	    int i2 = ((Integer)(v2.elementAt(c2))).intValue();

	    if (i1 < i2)
		c1++;
	    else if (i1 > i2)
		c2++;
	    else {
		result.addElement(new Integer(i1));
		c1++;
		c2++;
	    }
	}

	System.out.print("AND result return: ");
	for (int i=0; i<result.size(); i++)
	    System.out.print(((Integer)(result.elementAt(i))).intValue() + " ");
	System.out.println();
	return result;
    }


    // compute "or" operator of the two query results
    private Vector Or(Vector v1, Vector v2) {

	int c1=0, c2=0;
	Vector result = new Vector();

	if ((null == v1) || (null == v2))
	    return null;

	while ((c1 < v1.size()) && (c2 < v2.size())) {
	    // get two integers from the two vectors
	    int i1 = ((Integer)(v1.elementAt(c1))).intValue();
	    int i2 = ((Integer)(v2.elementAt(c2))).intValue();

	    if (i1 < i2) {
		result.addElement(new Integer(i1));
		c1++;
	    }
	    else if (i1 > i2) {
		result.addElement(new Integer(i2));
		c2++;
	    }
	    else {
		result.addElement(new Integer(i1));
		c1++;
		c2++;
	    }
	}
	while (c1 < v1.size()) {
	    int i1 = ((Integer)(v1.elementAt(c1))).intValue();
	    result.addElement(new Integer(i1));
	    c1++;
	}
	while (c2 < v2.size()) {
	    int i2 = ((Integer)(v2.elementAt(c2))).intValue();
	    result.addElement(new Integer(i2));
	    c2++;
	}

	System.out.print("OR result return: ");
	for (int i=0; i<result.size(); i++)
	    System.out.print(((Integer)(result.elementAt(i))).intValue() + " ");
	System.out.println();
	return result;
    }

    // sort the returning result of a simple query
    private Vector sort(Vector oldV) {
	Vector newV = new Vector();
	// test whether it is a Integer array or a String array
	if (oldV.elementAt(0) instanceof String)
	    return oldV;

	// read all the digits of vector into an array
	int[] sortarray = new int[oldV.size()];
	for (int i=0; i<oldV.size(); i++)
	    sortarray[i] = ((Integer)(oldV.elementAt(i))).intValue();

	// sort the array
	Arrays.sort(sortarray);

	// write the sorted number in new Vector and delete duplicate
	int last = -1;
	int curr ;
	for (int i=0; i<oldV.size(); i++) {
	    curr = sortarray[i];
	    if (curr != last) {
		newV.addElement(new Integer(curr));
		last = curr;
	    }
	}

	// print it out
	for (int i=0; i<oldV.size(); i++) 
	    System.out.print(((Integer)(oldV.elementAt(i))).intValue() + " ");
      	System.out.println();
	for (int i=0; i<newV.size(); i++) 
	    System.out.print(((Integer)(newV.elementAt(i))).intValue() + " ");
	System.out.println();

	return newV;
    }


    // print a tree
    private void print(treeNode n) {

	if (0 == (n.op).length()) {
	  
	    (n.query).print();
	}
	else {
	    System.out.println(n.op);
	    print(n.left);
	    print(n.right);
	}


    }

    private Vector test1() {
        Vector v = new Vector();
	v.addElement(new Integer(7));
	v.addElement(new Integer(10));
	v.addElement(new Integer(0));
	v.addElement(new Integer(3));
	return v;
    }

     private Vector test2() {
        Vector v = new Vector();
	v.addElement(new Integer(8));
	v.addElement(new Integer(3));
	v.addElement(new Integer(10));
	v.addElement(new Integer(1));
	return v;
    }

     private Vector test3() {
        Vector v = new Vector();
	v.addElement(new Integer(14));
	v.addElement(new Integer(5));
	v.addElement(new Integer(8));
	v.addElement(new Integer(0));
	v.addElement(new Integer(10));
	v.addElement(new Integer(0));
	v.addElement(new Integer(8));
	v.addElement(new Integer(16));
	return v;
    }

    private Vector test4() {
        Vector v = new Vector();
	v.addElement("john");
	v.addElement("jack");
	v.addElement("patrick");
	v.addElement("jim");
	return v;
    }
    public static void main(String[] args) {

	Tree tree = new Tree();
	tree.evaluate("(/text:/a & /type:) & ( /owner:/hds & /size:/839) | ((/fheu:/dsh & /dsh:/sda) & /hsaj:)");
    }

					    
}
