
/* This file will be the main file for our GFS file system. It will be 
 * executed whenever a query is presented, and user can then use the
 * query result to view the file and directory returned.
 */

import java.io.*;
import java.util.*;

public class gfs {

    public static void main(String[] args) throws IOException {

	/* %%%build the FileInfoV and temporily result tree for debugging */
	FileScan fs = new FileScan("/afs/cs.wisc.edu/u/w/j/wjin/course/cs736/project/GFS/test");
	Vector v = ourDB.searchType("class");
	for(int i=0; i<v.size(); i++) 
	    System.out.println(((Integer)(v.elementAt(i))).intValue() + " ");
	ourDB.dumpFileInfoV();
	//ourDB.writeFileInfoV();
	//ourDB.readFileInfoV();
	//QueryResultTree.build();
	/* %%% end */

	gfs our_gfs = new gfs();

	Tree tree = new Tree();

	BufferedReader stdin = new BufferedReader(new InputStreamReader
			       (System.in));

	Vector comm_args = new Vector();

	String comm_line = null; // the command line read in
	
	// pass the query argument to query_handling function.
	//String query = "";
	//for (int i=0; i<args.length; i++)
	//    query = " " + args[i];

	// get the query result containing all the file number
	//Vector result = tree.evaluate(query);
	
	// construct SingleQueryResult object and add it to QueryResultTree
	//SingleQueryResult sqr = new SingleQueryResult();
	//for (int i=0; i<result.size(); i++) {
	//   if (result.elementAt(i) instanceof Integer) {
		// it is a file
	//	int pos = ((Integer)result.elementAt(i)).intValue();
	//	String name = ((FileInfoEntry)((ourDB.fileInfoV).elementAt(pos))).fileName;
	//	(sqr.singleResult).addElement(new QueryResultEntry(name,pos,-1));
	//   }
	//   else {
	//	String name = (String)result.elementAt(i);
	//	(sqr.singleResult).addElement(new QueryResultEntry(name,-1,-1));
	//   }
	//}
	//(QueryResultTree.resultTree).addElement(sqr);

	// show the query result to the querier
	//int pt = QueryResultTree.currQueryResult;
	//QueryResultTree.printResult(pt);

	//System.out.print("old command: "); ///////////
	//dump(comm_args);                   //////////

	// read the command line in gfs until user want to quit
	while (true) {
	    Vector new_comm = new Vector();

	    int count = 0; // count whether there is significant arg in command

	    our_gfs.print_prompt();
	    
	    comm_line = stdin.readLine();
	    
	    comm_args = our_gfs.split(comm_line);

	    //%%% dump(comm_args);
	    // do things according to the command
	    String cmd = (String)(comm_args.firstElement());
	    
	    // "gfs" query command
	    if (cmd.equals("gfs")) {

		// get rid of the old result tree cache
		QueryResultTree.renew();
		
		// get the query string
		String query = "";
		for (int i=1; i<comm_args.size(); i++)
		    query = query + " " + (String)(comm_args.elementAt(i));

		System.out.println(query);
		// get the query result containing all the file number
		Vector result = tree.evaluate(query);
	
		if (null == result) {
		    //System.out.println("ERROR: query format is not correct");
		    continue;
		}
		// construct SingleQueryResult object and add it to QueryResultTree
		SingleQueryResult sqr = new SingleQueryResult();
		for (int i=0; i<result.size(); i++) {
		    if (result.elementAt(i) instanceof Integer) {
			// it is a file
			int pos = ((Integer)result.elementAt(i)).intValue();
			String name = ((FileInfoEntry)((ourDB.fileInfoV).elementAt(pos))).fileName;
			(sqr.singleResult).addElement(new QueryResultEntry(name,pos,-1));
		    }
		    else {
			String name = (String)result.elementAt(i);
			(sqr.singleResult).addElement(new QueryResultEntry(name,Tree.attribute,-1));
		    }
		}
		(QueryResultTree.resultTree).addElement(sqr);
		QueryResultTree.currQueryResult = 0;

		// show the query result to the querier
		int pt = QueryResultTree.currQueryResult;
		QueryResultTree.printResult(pt);

		continue;
	    }
	    // "vim" command
	    else if (cmd.equals("vim")) {
	
		// assign the command part of new converted command
		new_comm.addElement("vim");

		// convert cmd's argument from virtual dir to real dir
		for (int i=1; i<comm_args.size(); i++) {
		    
		    // check whether it is an option argument
		    if (((String)comm_args.elementAt(i)).startsWith("-")) {
			new_comm.addElement((String)comm_args.elementAt(i));
			continue;
		    }
		    
		    // check whether the name is a file or a dir
		    int id = QueryResultTree.search((String)comm_args.elementAt(i));
		    
		    System.out.println("id = " + id);
		    
		    if (Integer.MAX_VALUE == id) {
			// file name not found in the current query result
			new_comm.addElement((String)comm_args.elementAt(i));
			count++;
		    }
		    else if ( 0 <= id) {
			// it is a file, convert the symbolic link to abs path
			new_comm.addElement(ourDB.searchFileInfo(id));
			count++;
		    }
		    else {
			// it is a dir, so print an error
			System.out.println("ERROR: " + (String)comm_args.elementAt(i) +
					   " is a directory.");
		    }
		}

	    }
	    // "cp" command
	    else if (cmd.equals("cp")) {

		// assign the command part of new converted command
		new_comm.addElement("cp");

		// convert cmd's argument from virtual dir to real dir
		for (int i=1; i<comm_args.size(); i++) {
		    
		    // check whether it is an option argument
		    if (((String)comm_args.elementAt(i)).startsWith("-")) {
			new_comm.addElement((String)comm_args.elementAt(i));
			continue;
		    }

		    // check whether it is the last para in more than 2 paras
		    if ((i == comm_args.size()-1) && (2 <= count)) {
			String lastPara = (String)comm_args.elementAt(i);
			if (lastPara.startsWith("./") || lastPara.startsWith("/")) {
			    new_comm.addElement((String)comm_args.elementAt(i));
			    count++;
			    continue; 
			}
			else {
			    System.out.println("ERROR: last parameter should be a" +
					       " directory.");
			    count = 0;
			}
		    }
   
		    // check whether the name is a file or a dir
		    int id = QueryResultTree.search((String)comm_args.elementAt(i));
		    
		    
		    if (Integer.MAX_VALUE == id) {
			// file name is represented as real path in fs
			new_comm.addElement((String)comm_args.elementAt(i));
			count++;
		    }
		    else if ( 0 <= id) {
			// it is a file, convert the symbolic link to abs path
			new_comm.addElement(ourDB.searchFileInfo(id));
			count++;
		    }
		    else if (Integer.MIN_VALUE == id) {
			// there are some error occuring in searching
			continue;
		    }
		    else {
			// it is a dir, so print an error
			System.out.println("ERROR: " + (String)comm_args.elementAt(i) +
					   " is a virtual directory.");
			continue;
		    }
		}

		// check whether cp can be executed
		if (2 > count)
		    continue;

	    }
	    // "rm" command
	    else if (cmd.equals("rm")) {

		// assign the command part of new converted command
		new_comm.addElement("rm");

		// convert cmd's argument from virtual dir to real dir
		for (int i=1; i<comm_args.size(); i++) {
		    
		    // check whether it is an option argument
		    if (((String)comm_args.elementAt(i)).startsWith("-")) {
			new_comm.addElement((String)comm_args.elementAt(i));
			continue;
		    }

		    // check whether the name is a file or a dir
		    int id = QueryResultTree.search((String)comm_args.elementAt(i));
		    
		    
		    if (Integer.MAX_VALUE == id) {
			// file name is represented as real path in Unix
			new_comm.addElement((String)comm_args.elementAt(i));
			count++;
		    }
		    else if ( 0 <= id) {
			// it is a file, convert the symbolic link to abs path
			new_comm.addElement(ourDB.searchFileInfo(id));
			count++;
		    }
		    else if (Integer.MIN_VALUE == id) {
			// there are some error occuring in searching
			continue;
		    }
		    else {
			// it is a dir, so print an error
			System.out.println("ERROR: " + (String)comm_args.elementAt(i) +
					   " is a virtual directory.");
		    }
		}

		// check whether rm can be executed in Unix
		if (0 == count)
		    continue;

	    }
	    // "mv" command
	    else if (cmd.equals("mv")) {

		// assign the command part of new converted command
		new_comm.addElement("mv");

		// convert cmd's argument from virtual dir to real dir
		for (int i=1; i<comm_args.size(); i++) {
		    
		    // check whether it is an option argument
		    if (((String)comm_args.elementAt(i)).startsWith("-")) {
			new_comm.addElement((String)comm_args.elementAt(i));
			continue;
		    }

		    // check whether it is the last para in more than 2 paras
		    if ((i == comm_args.size()-1) && (2 <= count)) {
			String lastPara = (String)comm_args.elementAt(i);
			if (lastPara.startsWith("./") || lastPara.startsWith("/")) {
			    new_comm.addElement((String)comm_args.elementAt(i));
			    count++;
			    continue; 
			}
			else {
			    System.out.println("ERROR: last parameter should be a" +
					       " directory.");
			    count = 0;
			}
		    }
   
		    // check whether the name is a file or a dir
		    int id = QueryResultTree.search((String)comm_args.elementAt(i));
		    
		    
		    if (Integer.MAX_VALUE == id) {
			// file name is represented as real path in fs
			new_comm.addElement((String)comm_args.elementAt(i));
			count++;
		    }
		    else if ( 0 <= id) {
			// it is a file, convert the symbolic link to abs path
			new_comm.addElement(ourDB.searchFileInfo(id));
			count++;
		    }
		    else if (Integer.MIN_VALUE == id) {
			// there are some error occuring in searching
			continue;
		    }
		    else {
			// it is a dir, so print an error
			System.out.println("ERROR: " + (String)comm_args.elementAt(i) +
					   " is a virtual directory.");
			continue;
		    }
		}

		// check whether cp can be executed
		if (2 > count)
		    continue;

	    }
	    // "cat" command
	    else if (cmd.equals("cat")) {

		// assign the command part of new converted command
		new_comm.addElement("cat");

		// convert cmd's argument from virtual dir to real dir
		for (int i=1; i<comm_args.size(); i++) {
		    
		     // check whether it is an option argument
		    if (((String)comm_args.elementAt(i)).startsWith("-")) {
			new_comm.addElement((String)comm_args.elementAt(i));
			continue;
		    }

		    // check whether the name is a file or a dir
		    int id = QueryResultTree.search((String)comm_args.elementAt(i));
		    
		    
		    if (Integer.MAX_VALUE == id) {
			// file name is represented as real path in Unix
			new_comm.addElement((String)comm_args.elementAt(i));
			count++;
		    }
		    else if ( 0 <= id) {
			// it is a file, convert the symbolic link to abs path
			new_comm.addElement(ourDB.searchFileInfo(id));
			count++;
		    }
		    else if (Integer.MIN_VALUE == id) {
			// there are some error occuring in searching
			continue;
		    }
		    else {
			// it is a dir, so print an error
			System.out.println("ERROR: " + (String)comm_args.elementAt(i) +
					   " is a virtual directory.");
		    }
		}

		// check whether rm can be executed in Unix
		if (0 == count)
		    continue;
	    }
	    // "more" command
	    else if (cmd.equals("more")) {

		// assign the command part of new converted command
		new_comm.addElement("more");

		// convert cmd's argument from virtual dir to real dir
		for (int i=1; i<comm_args.size(); i++) {
		    
		    // check whether it is an option argument
		    if (((String)comm_args.elementAt(i)).startsWith("-")) {
			new_comm.addElement((String)comm_args.elementAt(i));
			continue;
		    }

		    // check whether the name is a file or a dir
		    int id = QueryResultTree.search((String)comm_args.elementAt(i));
		    
		    
		    if (Integer.MAX_VALUE == id) {
			// file name is represented as real path in Unix
			new_comm.addElement((String)comm_args.elementAt(i));
			count++;
		    }
		    else if ( 0 <= id) {
			// it is a file, convert the symbolic link to abs path
			new_comm.addElement(ourDB.searchFileInfo(id));
			count++;
		    }
		    else if (Integer.MIN_VALUE == id) {
			// there are some error occuring in searching
			continue;
		    }
		    else {
			// it is a dir, so print an error
			System.out.println("ERROR: " + (String)comm_args.elementAt(i) +
					   " is a virtual directory.");
		    }
		}

		// check whether rm can be executed in Unix
		if (0 == count)
		    continue;

	    }
	    // "ls" command
	    else if (cmd.equals("ls")) {

		boolean with_arg = false;

		// assign the command part of new converted command
		new_comm.addElement("ls");

		// convert cmd's argument from virtual dir to real dir
		for (int i=1; i<comm_args.size(); i++) {
		    
		    // check whether it is an option argument
		    if (((String)comm_args.elementAt(i)).startsWith("-")) {
			new_comm.addElement((String)comm_args.elementAt(i));
			continue;
		    }

		    // get the name of file or dir to be listed
		    String name = (String)comm_args.elementAt(i);
		    
		    // check whether the name is a file or a dir
		    int id = QueryResultTree.search(name);
		    		    
		    if (Integer.MAX_VALUE == id) {
			// file name is given in real path of Unix
			new_comm.addElement((String)comm_args.elementAt(i));
			count++;
			with_arg = true;
		    }
		    else if ( 0 <= id) {
			// it is a file, list it
			System.out.println((String)comm_args.elementAt(i));
			System.out.println();
			with_arg = true;
			//count++;
		    }
		    else if (Integer.MIN_VALUE == id) {
			// some error occured for the name given
			with_arg = true;
		    }
		    else {
			with_arg = true;

			System.out.println(name + ":");
				
			// it is a dir, it is equal to doing a query
			int child = QueryResultTree.searchPath(name);
					
			if ( 0 <= child) {
			    // the desired dir has a child(subquery exists)
			    QueryResultTree.printResult(child);
			    //((SingleQueryResult)((QueryResultTree.resultTree).elementAt(child))).list();
			}
			else if (Integer.MIN_VALUE == child) {
			    // there are some error occuring in searching
			}
			else {
			    // the desired dir has no child, do subquery
			    String para = name.toLowerCase();
			    Vector result;
			    if (-1 == child) {
				// get the query result containing all the file number
				result = tree.evaluate("/sender:/"+para);
			    }
			    else if (-2 == child) {
				result = tree.evaluate("/receiver:/"+para);
			    }
			    else if (-3 == child) {
				result = tree.evaluate("/owner:/"+para);
			    }
			    else {
				result = tree.evaluate("/type:/"+para);
			    }
			   
			    // construct SingleQueryResult object and add it to QueryResultTree
			    SingleQueryResult sqr = new SingleQueryResult();
			    for (int j=0; j<result.size(); j++) {
				if (result.elementAt(j) instanceof Integer) {
				    // it is a file
				    int pos = ((Integer)result.elementAt(j)).intValue();
				    String filename = ((FileInfoEntry)((ourDB.fileInfoV).elementAt(pos))).fileName;
				    (sqr.singleResult).addElement(new QueryResultEntry(filename,pos,-1));
				}
				else {
				    String dirname = (String)result.elementAt(j);
				    (sqr.singleResult).addElement(new QueryResultEntry(dirname,Tree.attribute,-1));
				}
			    }
			    sqr.parent = sqr.position;
			    (QueryResultTree.resultTree).addElement(sqr);
			    
			    // show the query result to the querier
			    int pt = (QueryResultTree.resultTree).size()-1;
			    QueryResultTree.printResult(pt);
			}
		    }
		}

		if ((0 == count) && (true == with_arg))
		    continue;
		else if ((0 == count) && (false == with_arg)) {
		    // list the result of current query
		    int pt = QueryResultTree.currQueryResult;
		    QueryResultTree.printResult(pt);
		    //QueryResultTree.listCurr(); // currently we ignore the option ****
		    continue;
		}
	    }
	    // "cd" command
	    else if (cmd.equals("cd")) {
		if (1 == comm_args.size())
		    // "cd" means return to previous Unix working directory
		    System.exit(0);
		else if (2 < comm_args.size()) {
		    System.out.println("cd: Too many arguments.");
		}
		else {
		    // get the directory string, and it must be a virtual directory
		    String dir = (String)comm_args.elementAt(1);

		    // if the name starts with '/' or "./", it refers to real dir
		    if (dir.startsWith("/") || dir.startsWith("./")) {
			System.out.println("ERROR: " + dir + " must be a virtual directory.");
			continue;
		    }

		    // check whether the subquery has been done(have child)
		    int child = QueryResultTree.searchPath(dir);
		    
		    if ( 0 <= child) {
			// the desired dir has a child(subquery exists)
			QueryResultTree.currQueryResult = child;
			continue;
		    }
		    else if (Integer.MIN_VALUE == child) {
			// there are some error occuring in searching
			continue;
		    }
		    else {
			// the desired dir has no child, do subquery
			Vector result;
			String para = dir.toLowerCase();
			if (-1 == child) {
			    // get the query result containing all the file number
			    result = tree.evaluate("/sender:/"+para);
			}
			else if (-2 == child) {
			    result = tree.evaluate("/receiver:/"+para);
			}
			else if (-3 == child) {
			    result = tree.evaluate("/owner:/"+para);
			}
			else {
			    result = tree.evaluate("/type:/"+para);
			}
			
			// construct SingleQueryResult object and add it to QueryResultTree
			SingleQueryResult sqr = new SingleQueryResult();
			for (int i=0; i<result.size(); i++) {
			    if (result.elementAt(i) instanceof Integer) {
				// it is a file
				int pos = ((Integer)result.elementAt(i)).intValue();
				String name = ((FileInfoEntry)((ourDB.fileInfoV).elementAt(pos))).fileName;
				(sqr.singleResult).addElement(new QueryResultEntry(name,pos,-1));
			    }
			    else {
				String name = (String)result.elementAt(i);
				(sqr.singleResult).addElement(new QueryResultEntry(name,Tree.attribute,-1));
			    }
			}
			sqr.parent = sqr.position;
			(QueryResultTree.resultTree).addElement(sqr);
	   
			QueryResultTree.currQueryResult = (QueryResultTree.resultTree).size()-1;
			continue;
		    }
		}
	    }
	    // unsupported commands
	    else {
		System.out.println(cmd + ": Command not found.");
		continue;
	    }
					 
	    // execute the newly created command in Unix 
	    if ( 0 == count)
		continue;

	    Thread t = new Thread(new Command(new_comm));
	    t.start();
	    try {
		t.join();
	    }
	    catch (InterruptedException e) {
		System.out.println("ERROR: " + e.toString());
		System.exit(0);
	    }
	    System.out.print("old command: ");
	    dump(comm_args);
	    System.out.print("new command: ");
	    dump(new_comm);
	}    
	    
    }

    // print the GFS prompt
    private void print_prompt() {
	
	System.out.print("GFS>");
    }

    // split the command line read
    private Vector split(String comm_line) {

	Vector vec = new Vector();
	
	StringTokenizer tokens = new StringTokenizer(comm_line, " ");
	while (tokens.hasMoreTokens()) {
	    vec.addElement(tokens.nextToken());
	}

	return vec;
    }

    private static void dump(Vector vec) {
	for (int i=0; i<vec.size(); i++)
	    System.out.print((String)vec.elementAt(i)+" ");
	System.out.println();
    }
}
