import java.util.*;
import java.io.*;

public class ourDB {


    // vector for storing the object(fileInfoEntry) consists of file name, 
    // file path  name and file types
    // this vector is build by the file categorization 
    public static Vector fileInfoV = new Vector();
    
    // vector for free filenum position which can be used by new files
    private static Vector fileNumFreeList = new Vector();

    // vector  for storing objects(vector of attributes used by transducer
    // to filter useful information) for each file type; 
    public static Vector fileTransV;
    
    // hash table used to store B+tree of each bucket for full-text search;
    public static  Hashtable fullTextH;

    public static void dumpFileInfoV()
    {
	System.out.println("Dump fileInfo Vector:");
	for (int i=0; i<fileInfoV.size(); i++)
	{
	    System.out.print(i + ":  ");
	    System.out.print(((FileInfoEntry)fileInfoV.elementAt(i)).fileName+"   ");
	    System.out.print(((FileInfoEntry)fileInfoV.elementAt(i)).filePathName+"   ");
	    System.out.println(((FileInfoEntry)fileInfoV.elementAt(i)).fileType);
	}
    }

    public static void writeFileInfoV() 
    {
	try {
	    FileOutputStream fos = new FileOutputStream("writetemp");
	    ObjectOutputStream out = new ObjectOutputStream(fos);

	    out.writeObject(fileInfoV);
	    out.flush();
	    out.close();
	}
	catch (Exception e) { System.out.println("ERROR: " + e.toString());}


    }

    public static void readFileInfoV()
    {
	Vector newFileInfoV = new Vector();

	try {
	    FileInputStream fis = new FileInputStream("writetemp");
	    ObjectInputStream in = new ObjectInputStream(fis);

	    newFileInfoV = (Vector)in.readObject();
	    in.close();
	}
	catch (Exception e) { System.out.println("ERROR: " + e.toString());}
	
	System.out.println("Dump reread fileInfo Vector:");
	for (int i=0; i<newFileInfoV.size(); i++)
	{
	    System.out.print(i + ":  ");
	    System.out.print(((FileInfoEntry)newFileInfoV.elementAt(i)).fileName+"   ");
	    System.out.print(((FileInfoEntry)newFileInfoV.elementAt(i)).filePathName+"   ");
	    System.out.println(((FileInfoEntry)newFileInfoV.elementAt(i)).fileType);
	}

    }
    public static void dumpFileNumFreeList()
    {
	System.out.println("Dump fileNumFreeList:");
	for (int i=0; i<fileNumFreeList.size(); i++)
	{
	    System.out.print(i + ":  ");
	    System.out.println(((Integer)fileNumFreeList.elementAt(i)).intValue());
	}
    }

    // Insert new file information into FileInfo vector
    public static int insertFileInfo(String absPath) 
    {
	// Get the corresponding name, path and type of the file
	String name = absPath.substring(absPath.lastIndexOf((int)'/')+1);
	File file = new File(absPath);
	String type = FileScan.checkType(file);
	int pos = -1; // the position that new fileInfoEntry would be inserted

	// check the free positions in fileNumFreeList, if there is any, add the
	// new entry to the corresponding pos, otherwise add it to the end.
	if (fileNumFreeList.isEmpty()) {
	    fileInfoV.add(new FileInfoEntry(name,absPath,type));
	    pos = fileInfoV.size() - 1;
	}
	else {
	    try {
		pos = ((Integer)fileNumFreeList.firstElement()).intValue();
		fileNumFreeList.removeElementAt(0);
	   
		fileInfoV.setElementAt(new FileInfoEntry(name,absPath,type),pos);
	    }
	    catch (Exception e) { 
		System.out.println("ERROR: " + e.toString());
		System.exit(0);
	    }
	}

	return pos;
	
    }

    // delete old files from FileInfoV vector
    public static boolean delFileInfo(int fileNum)
    {
	boolean status = true;
	
	// invalidate this fileNum from FileInfoV
	FileInfoEntry invalid = new FileInfoEntry("","","");

	try {
	    fileInfoV.setElementAt(invalid,fileNum);
	}
	catch (Exception e) { 
	    System.out.println("ERROR: "+ e.toString()); 
	    status = false;
	}

	// add this free pos num to fileNumFreeList
	Integer new_pos = new Integer(fileNum);
	fileNumFreeList.addElement(new_pos);

	return true;
    }

    // search the path for a particular fileNum in fileInfoV
    public static String searchFileInfo(int fileNum) {

	return ((FileInfoEntry)(fileInfoV.elementAt(fileNum))).filePathName;

    }

    /* The method will go throgh all the file items in FileInfoV and get the
     * file numbers of a certain type. */
    public static Vector searchType(String type) {

	Vector result = new Vector();

	for(int i=0; i<fileInfoV.size(); i++) {
	    String filetype = ((FileInfoEntry)(fileInfoV.elementAt(i))).fileType;
	    filetype = filetype.toLowerCase();
	    type = type.toLowerCase();
	    if (filetype.startsWith(type)) {
		// find a file whose type is string "type"
		result.addElement(new Integer(i));
	    }
	}

	return result;
    }						      
}
